package eu.dnetlib.irishmonitorservice.controllers;

import eu.dnetlib.irishmonitorservice.configuration.properties.StatsToolProperties;
import eu.dnetlib.irishmonitorservice.entities.StakeholderPublications;
import eu.dnetlib.irishmonitorservice.utils.StatsToolUtils;
import eu.dnetlib.uoamonitorservice.entities.Stakeholder;
import eu.dnetlib.uoamonitorservice.service.StakeholderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("publications")
public class StakeholderPublicationsController {

    @Autowired
    private StakeholderService service;

    @Autowired
    private StatsToolUtils utils;

    public List<List<String>> getResponse(String type) throws UnsupportedEncodingException {
        if(type.equals("funder")) {
            return this.utils.getFunders();
        } else if(type.equals("organization")) {
            return this.utils.getOrganizations();
        } else if(type.equals("datasource")) {
            return this.utils.getDataSources();
        } else {
            return null;
        }
    }

    @RequestMapping(value = "/{type}", method = RequestMethod.GET)
    public List<StakeholderPublications> getStakeholders(@PathVariable String type) throws UnsupportedEncodingException, InterruptedException {
        List<Stakeholder> stakeholders = this.service.getStakeholdersByTypeAndRole(type, null, false);
        List<StakeholderPublications> stakeholderPublications = new ArrayList<>();
        List<List<String>> data = this.getResponse(type);
        List<Stakeholder> remain = new ArrayList<>(stakeholders);
        if (data != null) {
            data.forEach(entity -> {
                String id = entity.get(1);
                stakeholders.stream().filter(stakeholder -> stakeholder.getIndex_id().equals(id)).findFirst().ifPresent(stakeholder -> {
                    remain.remove(stakeholder);
                    stakeholderPublications.add(new StakeholderPublications(stakeholder, Integer.parseInt(entity.get(0))));
                });
            });
        }
        remain.forEach(stakeholder -> stakeholderPublications.add(new StakeholderPublications(stakeholder, 0)));
        return stakeholderPublications;
    }
}
